/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.ejb3.test.regression;

import java.io.Serializable;
import javax.ejb.PrePassivate;
import javax.ejb.Remote;
import javax.ejb.Stateful;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContext;
import javax.transaction.UserTransaction;
import javax.persistence.PersistenceContext;
import org.jboss.annotation.ejb.cache.simple.CacheConfig;
import org.jboss.ejb3.Container;

/**
 * comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 */
@Stateful
@CacheConfig(maxSize = 1000, idleTimeoutSeconds = 1)
@Remote(PassivationTest.class)
public class PassivationTestBean implements PassivationTest, Serializable
{
   @PersistenceContext private EntityManager em;


   public String echo(String echo)
   {
      System.out.println("***: " + echo);
      try
      {
         InitialContext ctx = new InitialContext();
         UserTransaction ut = (UserTransaction)ctx.lookup(Container.ENC_CTX_NAME + "/UserTransaction");
         Context env = (Context)ctx.lookup(Container.ENC_CTX_NAME + "/env");
         EntityManager em2 = (EntityManager)env.lookup("EntityManager");
      }
      catch (NamingException e)
      {
         throw new RuntimeException(e);
      }
      return echo;
   }

   public void createContact()
   {
      Contact c = new Contact();
      c.setEmail("bill@jboss.org");
      c.setName("Bill");
      c.setPhone("666-666-6666");
      em.persist(c);
   }

   @PrePassivate
   public void prePassivate()
   {
      System.out.println("PASSIVATING!!!");
   }
}
